﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CognitiveScience
{
    class JaroWinkler
    {
        public static double jwDistance(List<string> A, List<string> B)
        { 
            //compute Jaro-Wrinkler distance between A and B
            int s1 = A.Count, s2 = B.Count;
            int matching = 0;

            int window = (int)(Math.Max(s1, s2) / 2) - 1;
            int[] matchesA = new int[A.Count];
            int[] matchesB = new int[B.Count];
            for (int i = 0; i < matchesB.Count(); i++)
                matchesB[i] = -1;

            for(int i=0;i<A.Count;i++)
            {
                matchesA[i] = -1;
                for (int j = Math.Max(0, i - window); j <= Math.Min(B.Count - 1, i + window); j++)
                {
                    if (A[i].Equals(B[j]))
                    {
                        matchesA[i] = j;
                        matchesB[j] = i;
                        matching++;
                        break;
                    }
                }
            }

            if (matching == 0)
                return 0;

            List<string> Atmp = new List<string>();
            List<string> Btmp = new List<string>();

            for (int i = 0; i < matchesA.Count(); i++)            
            {
                if(matchesA[i]>=0)
                    Atmp.Add(A[i]);
            }

            for (int i = 0; i < matchesB.Count(); i++)
            {
                if(matchesB[i]>=0)
                    Btmp.Add(B[i]);            
            }            

            //note that size of Atmp and Btmp is same
            int t=0;
            for (int i = 0; i < Atmp.Count; i++)
            {
                if (!Atmp[i].Equals(Btmp[i]))
                    t++;
            }

            t = t / 2;            
            double dist = (1.0 / 3.0)*((double)matching/(double)s1 + (double)matching/(double)s2 + (double)(matching-t)/(double)matching);

            return dist;
        }

    }
}
