﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CognitiveScience
{
    class Program
    {
        /*Useful Datastructure*/

        public static List<string> landmarks=new List<string>(){"AS","EB","CC","FB","LB","AD","SC","LH","WL","MT","H1","H2","H3","H5","TC","H7","CF","NS","HC","KV" };       
        public static List<double> latitude = new List<double>(){ 26.520139, 26.515636, 26.514009, 26.513049, 26.512079, 26.513034, 26.511690, 26.511561, 26.512430, 26.512007, 26.509415, 26.510356, 26.508628, 26.509516, 26.509569, 26.506549, 26.509184, 26.504850, 26.504970, 26.508325 };
        public static List<double> longitude = new List<double>(){ 80.232575, 80.234013, 80.234571, 80.233342, 80.233841, 80.235724, 80.236287, 80.233068, 80.231824, 80.230370, 80.231963, 80.230011, 80.229887, 80.228584, 80.229968, 80.228466, 80.233530, 80.229426, 80.233777, 80.236191 };

        public static Tree currentTree = null;
        public static List<string> toGo = new List<string>();
        public static List<int> history = new List<int>();

        public static double a, b, c, d,e;

        public static List<Tuple<double, double, double, double,double>> neighbhors()
        {
            List<Tuple<double, double, double,double,double>> ngbr = new List<Tuple<double, double, double,double,double>>();
            List<double> val=new List<double>(){-20,20};
            foreach (double x in val)
            {
                foreach (double y in val)
                {
                    foreach (double z in val)
                    {
                        foreach (double u in val)
                        {
                            foreach (double v in val)
                                ngbr.Add(new Tuple<double, double, double, double, double>(a + x, b + y, c + z, d + u,e+v));
                        }
                    }
                }
            }
            return ngbr;
        }        

        public static Tuple<double,double,double,double,double,double> init(int user)
        {
            int step = 0;
            while (step < 500)
            {
                double distance = 0;
                for (int task = 0; task < 5; task++)
                {
                    history.Clear();
                    distance += start(Data.start[task], a, b, c, d, e, user, task);
                }

                //choose a neighbhorhood of a,b,c,d 
                List<Tuple<double,double, double, double,double>> ngbr = neighbhors();
                List<double> distances = new List<double>();
                foreach (Tuple<double, double, double, double,double> tmp in ngbr)
                {
                    double tmpDistance = 0;
                    for (int task = 0; task < 5; task++)
                    {
                        history.Clear();
                        tmpDistance += start(Data.start[task], tmp.Item1, tmp.Item2, tmp.Item3, tmp.Item4, tmp.Item5, user, task);
                    }
                    distances.Add(tmpDistance);
                }

                double maxD = distances.Max();
                if (maxD <= distance) //reached local maxima
                {
                    Console.WriteLine("Answer for task Number 5");
                    for (int i = 0; i < history.Count; i++)
                    {
                        String str=null;
                        if(history[i]==0)
                            str="CG";
                        else str="CM";
                        Console.WriteLine(str+"  ");
                    }
                    Console.WriteLine("----------");
                    return new Tuple<double, double, double,double, double, double>(a, b, c,d, e, distance);
                }

                for (int iter = 0; iter < distances.Count; iter++)
                {
                    if (distances[iter] == maxD)
                    {
                        a = ngbr[iter].Item1;
                        b = ngbr[iter].Item2;
                        c = ngbr[iter].Item3;
                        d = ngbr[iter].Item4;
                        e = ngbr[iter].Item5;
                        break;
                    }
                }
                Console.WriteLine("Maximum Distance is Now "+(maxD/5.0).ToString());                
                step++;
            }
            return null;
        }

        public static double start(string present, double a, double b, double c, double d,double e,int user, int task)
        {
            //c = 0; d = 0;  e = 0;  //Zeroth order markovian
            //d =0; e=0;  //first order markovian 
            //e=0;  //second order markovian
            List<string> answer=new List<string>();
            switch (task)
            {
                case 0: toGo = Data.target1.ToList(); break;
                case 1: toGo = Data.target2.ToList(); break;
                case 2: toGo = Data.target3.ToList(); break;
                case 3: toGo = Data.target4.ToList(); break;
                case 4: toGo = Data.target5.ToList(); break;
            }
            
            while(toGo.Count != 0)            
            {                

                /* We compute two features for all heuristic
                 * Feature 1 :  average distance between these locations
                 * Feature 2 :  1/Number of regions covered in one go
                 */

                Tree giveNode = currentTree.giveNode(present);
                /*apply heuristic 1  (Coarse to Fine region)
                 * - finish all points inside the region
                 * - find shortest point to other region
                 * - on reaching the region, find the nearest point
                 * - restart
                 */

                                
                Tree nextRegionCG = currentTree.findRegionCoarseToGrain(giveNode, toGo);
                //finish landmarks in this region in greedy shortest path method
                List<Tree> answerCG = nextRegionCG.walkShort(giveNode, nextRegionCG, toGo);
                double biasCG0, biasCM0, biasCG1, biasCM1, biasCM2, biasCG2;

                if (history.Count != 0)
                {
                    if (history[history.Count - 1] == 0)//CG strategy                    
                        biasCG0 = 0;                                            
                    else biasCG0 = 1;
                    biasCM0 = (biasCG0 + 1) % 2;  // 0 -> 1, 1 -> 0
                }
                else
                {
                    biasCG0 = 0;
                    biasCM0 = 0;
                }

                if (history.Count > 1)
                {
                    if (history[history.Count - 2] == 0) //CG strategy
                        biasCG1 = 0;
                    else biasCG1 = 1;
                    biasCM1 = (biasCG1 + 1) % 2; // 0 -> 1 ,1 -> 0
                }
                else
                {
                    biasCG1 = 0;
                    biasCM1 = 0;
                }

                if (history.Count > 2)
                {
                    if (history[history.Count - 3] == 0) //CG strategy
                        biasCG2 = 0;
                    else biasCG2 = 1;
                    biasCM2 = (biasCG2 + 1) % 2; // 0 -> 1 ,1 -> 0
                }
                else
                {
                    biasCG2 = 0;
                    biasCM2 = 0;
                }



                double f1CG=currentTree.featureDistance(giveNode,answerCG), f2CG=1/answerCG.Count;
                double costCG = a * f1CG + b * f2CG + c * biasCG0 + d*biasCG1 + e*biasCG2;
                //end of episode
                
                /* apply heuristic 2 (Clustering Method)
                 * - go to region with maximum cluster
                 * - finish points in that region
                 * - restart
                 */
                Tree nextRegionCM = currentTree.findRegionClusteringMethod(giveNode, toGo);
                //finish landmarks in this region in greedy shortest path method
                List<Tree> answerCM = nextRegionCM.walkShort(giveNode, nextRegionCM, toGo);

                double f1CM = currentTree.featureDistance(giveNode, answerCM), f2CM = 1/answerCM.Count;
                double costCM = a * f1CM + b * f2CM + c * biasCM0 + d*biasCM1 + e*biasCM2;
                //end of episode

                List<Tree> removable=null;

                //go with minimum cost heuristic
                if (costCG < costCM)
                {
                    removable = answerCG;
                    history.Add(0);
                }
                else
                {
                    removable = answerCM;
                    history.Add(1);
                }

                present = removable[removable.Count - 1].name; //the new location                
                foreach (Tree t in removable)
                {
                    answer.Add(t.name);
                    Console.Write(t.name+"  ");
                    toGo.Remove(t.name);
                }
            }

            double distance=0;
            switch(user)
            {
                case 0: distance = JaroWinkler.jwDistance(answer, Data.user1[task]); break;
                case 1: distance = JaroWinkler.jwDistance(answer, Data.user2[task]); break;
                case 2: distance = JaroWinkler.jwDistance(answer, Data.user3[task]); break;
                case 3: distance = JaroWinkler.jwDistance(answer, Data.user4[task]); break;
                case 4: distance = JaroWinkler.jwDistance(answer, Data.user5[task]); break;
            }
            return distance;
        }

        static void Main(string[] args)
        {            
            Data.initUserResponse();
            Data.initTree();
            //for (int user = 0; user < 1; user++) //currently only for 1 user
            //{
                currentTree = Data.t4;
                a = 1;
                b = 1;
                c = 1;
                d = 1;
                e = 1;
            
                Tuple<double,double,double,double,double,double> ans=init(3);
                if (ans == null)
                {
                    Console.WriteLine("Did not converge");
                }
                else
                {
                    Console.WriteLine("Converged with value of a="+ans.Item1.ToString()+", b="+ans.Item2.ToString()+", c="+ans.Item3.ToString()+", d= "+ans.Item4.ToString()+", e ="+ans.Item5.ToString());
                    Console.WriteLine("Similarity Score : "+(ans.Item6/5).ToString());
                }
                Console.WriteLine("Press a key to conitnue...");
                Console.Read();
            //}
            Console.WriteLine("Exiting");
        }
    }
}
